unit futureLabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Extctrls, mmsystem;

type
  TfutureLabel = class(TLabel)
  private
    FFontOut : TFont;
    FFontTemp: TFont;
    FWAVFileName: string;
    FSound: Boolean;
    FRollOver : Boolean;	
    procedure SetFontOut(Value : TFont);
    procedure SetFontTemp(Value : TFont);
    property FontTemp : TFont read FFontTemp write SetFontTemp;
    { Private declarations }
  protected
    procedure CMMouseEnter(var msg : TMessage) ; message CM_MOUSEENTER;
    procedure CMMouseLeave(var msg : TMessage) ; message CM_MOUSELEAVE;
    { Protected declarations }
  public
    constructor Create(AOwner : TComponent) ; override;
    destructor Destroy; override;
    { Public declarations }
  published
    property FontOut : TFont read FFontOut write SetFontOut;
    property WAVFileName : string read FWAVFileName write FWAVFileName;
    property Sound: Boolean read FSound write FSound;
    property RollOver: Boolean read FRollOver write FRollOver;	
    { Published declarations }
  end;

procedure Register;

implementation

constructor TfutureLabel.Create(AOwner : TComponent);
begin
     inherited Create(AOwner);
     FFontOut:=TFont.Create;
     FFontTemp:=TFont.Create;
end;

destructor TfutureLabel.Destroy;
begin
     FFontOut.Free;
     FFontTemp.Free;
     inherited Destroy;
end;

procedure TfutureLabel.SetFontOut(Value : TFont);
begin
     FFontOut.Assign(Value);
end;

procedure TfutureLabel.SetFontTemp(Value : TFont);
begin
     FFontTemp.Assign(Value);
end;

procedure TfutureLabel.CMMouseEnter(var Msg: TMessage);
label l1;
begin
     inherited;
     if not Sound then goto l1;
     if WAVFileName<>'' then sndPlaySound(PChar(WAVFileName), SND_ASYNC);
l1:     if not RollOver then Exit;	
     FontTemp:=Font;
     Font:=FontOut;
end;

procedure TfutureLabel.CMMouseLeave(var Msg: TMessage);
begin
     inherited;
     if not RollOver then Exit;	
     Font:=FontTemp;
end;

procedure Register;
begin
     RegisterComponents('Samples', [TfutureLabel]);
end;

end.
